unit order;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,Graphics,LCLProc;

const
  ESYNTAX=3;
  ECANTREAD=1;
  ECANTWRITE=2;
  ENONE=0;
type
  TParams=array of string;
  PCanvas=^TCanvas;

Procedure SetSize(x,y:integer; ac:PCanvas);
procedure TextOut(x,y:integer;Text:string; ac:PCanvas);
procedure Line(x,y,x2,y2:integer; ac:PCanvas);
procedure Rect(x1,y1,x2,y2:integer; ac:PCanvas);
procedure FilledRect(x1,y1,x2,y2:integer; ac:PCanvas);
procedure SetBrushColor(Color:TColor; ac:PCanvas);
procedure SetPenColor(Color:TColor; ac:PCanvas);

function DoInterprete(alff,astf:string):integer;
function SplitParams(s:string; out par:TParams):boolean;
function InitFile:boolean;
var tf:TextFile;
    stf,lff:string;

implementation

function InitFile:boolean;
begin
  Assignfile(tf,lff);
  try
    reset(tf);
    InitFile:=true;
  except
    InitFile:=false;
  end;
end;


function SplitParams(s:string; out par:TParams):boolean;
var x:integer;
begin
  SplitParams:=true;
  Setlength(par,0);
  if (s[1]<>'(') or (s[Length(s)]<>')') then
  begin
    SplitParams:=false;
    exit;
  end;
  x:=2;
  while x<Length(s) do
  begin
    SetLength(par,Length(par)+1);
    par[High(par)]:='';
    while (s[x]<>',') and (s[x]<>')') do
    begin
      par[High(par)]:=par[High(par)]+s[x];
      inc(x);
    end;
  end;
end;


function DoInterprete(alff,astf:string):integer;
var c:TCanvas;
    s:string;
    i:integer;
    params:TParams;
begin
  if not InitFile then
  begin
    DoInterprete:=ECANTREAD;
    exit;
  end;
  lff:=alff;
  stf:=astf;
  c:=TCanvas.Create;
  while not eof(tf) do
  begin
    Readln(tf,s);
    i:=1;
    while i<=Length(s) do
    begin
      case s[i] of
      '#': begin
           // Setze Größe:
             if not SplitParams(UTF8Copy(s,2,Length(s)-1),params) then
             begin
               DoInterprete:=ESYNTAX;
               exit;
             end;
             SetSize(strtoint(params[0]),strtoint(params[1]),@c);
           end;
      end;

    end;
  end;
  c.Free;
end;


Procedure SetSize(x,y:integer; ac:PCanvas);
begin
//  ac^.
{  ac^.Width:=x;
  ac^.Height:=y;}
end;

procedure TextOut(x,y:integer;Text:string; ac:PCanvas);
begin
  ac^.TextOut(x,y,Text);
end;

procedure Line(x,y,x2,y2:integer; ac:PCanvas);
begin
  ac^.Line(x,y,x2,y2);
end;

procedure Rect(x1,y1,x2,y2:integer; ac:PCanvas);
begin
  ac^.Rectangle(x1,y1,x2,y2);
end;

procedure FilledRect(x1,y1,x2,y2:integer; ac:PCanvas);
begin
  ac^.FillRect(x1,y1,x2,y2);
end;

procedure SetBrushColor(Color:TColor; ac:PCanvas);
begin
  ac^.Brush.Color:=Color;
end;

procedure SetPenColor(Color:TColor; ac:PCanvas);
begin
  ac^.Pen.Color:=Color;
end;

end.

